diff --git a/drivers/net/nfp/flower/nfp_conntrack.h b/drivers/net/nfp/flower/nfp_conntrack.h
index 5abab4e984..9bfca236ed 100644
--- a/drivers/net/nfp/flower/nfp_conntrack.h
+++ b/drivers/net/nfp/flower/nfp_conntrack.h
@@ -11,7 +11,7 @@
 #include <ethdev_driver.h>
 #include <rte_flow.h>
 
-#include "../nfp_flow.h"
+#include "nfp_flower_flow.h"
 
 struct nfp_ct_map_entry;
 
diff --git a/drivers/net/nfp/flower/nfp_flower_cmsg.h b/drivers/net/nfp/flower/nfp_flower_cmsg.h
index c2938fb6f6..45543816ae 100644
--- a/drivers/net/nfp/flower/nfp_flower_cmsg.h
+++ b/drivers/net/nfp/flower/nfp_flower_cmsg.h
@@ -6,8 +6,8 @@
 #ifndef __NFP_CMSG_H__
 #define __NFP_CMSG_H__
 
-#include "../nfp_flow.h"
 #include "nfp_flower.h"
+#include "nfp_flower_flow.h"
 
 struct nfp_flower_cmsg_hdr {
 	rte_be16_t pad;
diff --git a/drivers/net/nfp/nfp_flow.c b/drivers/net/nfp/flower/nfp_flower_flow.c
similarity index 99%
rename from drivers/net/nfp/nfp_flow.c
rename to drivers/net/nfp/flower/nfp_flower_flow.c
index f832b52d89..e26be30d18 100644
--- a/drivers/net/nfp/nfp_flow.c
+++ b/drivers/net/nfp/flower/nfp_flower_flow.c
@@ -3,7 +3,7 @@
  * All rights reserved.
  */
 
-#include "nfp_flow.h"
+#include "nfp_flower_flow.h"
 
 #include <rte_flow_driver.h>
 #include <rte_hash.h>
@@ -4318,7 +4318,7 @@ static const struct rte_flow_ops nfp_flow_ops = {
 };
 
 int
-nfp_net_flow_ops_get(struct rte_eth_dev *dev,
+nfp_flow_ops_get(struct rte_eth_dev *dev,
 		const struct rte_flow_ops **ops)
 {
 	if ((dev->data->dev_flags & RTE_ETH_DEV_REPRESENTOR) == 0) {
diff --git a/drivers/net/nfp/nfp_flow.h b/drivers/net/nfp/flower/nfp_flower_flow.h
similarity index 96%
rename from drivers/net/nfp/nfp_flow.h
rename to drivers/net/nfp/flower/nfp_flower_flow.h
index 09e5b30dd8..75f18c6bd5 100644
--- a/drivers/net/nfp/nfp_flow.h
+++ b/drivers/net/nfp/flower/nfp_flower_flow.h
@@ -3,10 +3,10 @@
  * All rights reserved.
  */
 
-#ifndef __NFP_FLOW_H__
-#define __NFP_FLOW_H__
+#ifndef __NFP_FLOWER_FLOW_H__
+#define __NFP_FLOWER_FLOW_H__
 
-#include "nfp_net_common.h"
+#include "../nfp_net_common.h"
 
 /* The firmware expects lengths in units of long words */
 #define NFP_FL_LW_SIZ                   2
@@ -182,7 +182,7 @@ struct nfp_flower_representor;
 
 int nfp_flow_priv_init(struct nfp_pf_dev *pf_dev);
 void nfp_flow_priv_uninit(struct nfp_pf_dev *pf_dev);
-int nfp_net_flow_ops_get(struct rte_eth_dev *dev, const struct rte_flow_ops **ops);
+int nfp_flow_ops_get(struct rte_eth_dev *dev, const struct rte_flow_ops **ops);
 bool nfp_flow_inner_item_get(const struct rte_flow_item items[],
 		const struct rte_flow_item **inner_item);
 struct rte_flow *nfp_flow_process(struct nfp_flower_representor *representor,
@@ -202,4 +202,4 @@ int nfp_flow_destroy(struct rte_eth_dev *dev,
 		struct rte_flow *nfp_flow,
 		struct rte_flow_error *error);
 
-#endif /* __NFP_FLOW_H__ */
+#endif /* __NFP_FLOWER_FLOW_H__ */
diff --git a/drivers/net/nfp/flower/nfp_flower_representor.c b/drivers/net/nfp/flower/nfp_flower_representor.c
index 02089d390e..7d8c055b80 100644
--- a/drivers/net/nfp/flower/nfp_flower_representor.c
+++ b/drivers/net/nfp/flower/nfp_flower_representor.c
@@ -435,7 +435,7 @@ static const struct eth_dev_ops nfp_flower_repr_dev_ops = {
 	.mac_addr_set         = nfp_flower_repr_mac_addr_set,
 	.fw_version_get       = nfp_net_firmware_version_get,
 
-	.flow_ops_get         = nfp_net_flow_ops_get,
+	.flow_ops_get         = nfp_flow_ops_get,
 	.mtr_ops_get          = nfp_net_mtr_ops_get,
 };
 
diff --git a/drivers/net/nfp/meson.build b/drivers/net/nfp/meson.build
index cf9c16266d..8407073af8 100644
--- a/drivers/net/nfp/meson.build
+++ b/drivers/net/nfp/meson.build
@@ -11,6 +11,7 @@ sources = files(
         'flower/nfp_flower.c',
         'flower/nfp_flower_cmsg.c',
         'flower/nfp_flower_ctrl.c',
+        'flower/nfp_flower_flow.c',
         'flower/nfp_flower_representor.c',
         'nfd3/nfp_nfd3_dp.c',
         'nfdk/nfp_nfdk_dp.c',
@@ -30,7 +31,6 @@ sources = files(
         'nfp_cpp_bridge.c',
         'nfp_ethdev.c',
         'nfp_ethdev_vf.c',
-        'nfp_flow.c',
         'nfp_ipsec.c',
         'nfp_logs.c',
         'nfp_mtr.c',